/***************************************************************************
 * SPDX-FileCopyrightText: 2024 S. MANKOWSKI stephane@mankowski.fr
 * SPDX-FileCopyrightText: 2024 G. DE BURE support@mankowski.fr
 * SPDX-License-Identifier: GPL-3.0-or-later
 ***************************************************************************/

/****************************************************************************
**
** Copy right ( C ) 2012 Digia Plc and/or its subsidiary(-ies).
** Contact: http://www.qt-project.org/legal
**
** This file is part of the test suite of the Qt Toolkit.
**
** $QT_BEGIN_LICENSE:LGPL$
** Commercial License Usage
** Licensees holding valid commercial Qt licenses may use this file in
** accordance with the commercial license agreement provided with the
** Software or, alternatively, in accordance with the terms contained in
** a written agreement between you and Digia.  For licensing terms and
** conditions see http://qt.digia.com/licensing.  For further information
** use the contact form at http://qt.digia.com/contact-us.
**
** GNU Lesser General Public License Usage
** Alternatively, this file may be used under the terms of the GNU Lesser
** General Public License version 2.1 as published by the Free Software
** Foundation and appearing in the file LICENSE.LGPL included in the
** packaging of this file.  Please review the following information to
** ensure the GNU Lesser General Public License version 2.1 requirements
** will be met: http://www.gnu.org/licenses/old-licenses/lgpl-2.1.html.
**
** In addition, as a special exception, Digia gives you certain additional
** rights.  These rights are described in the Digia Qt LGPL Exception
** version 1.1, included in the file LGPL_EXCEPTION.txt in this package.
**
** GNU General Public License Usage
** Alternatively, this file may be used under the terms of the GNU
** General Public License version 3.0 as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL included in the
** packaging of this file.  Please review the following information to
** ensure the GNU General Public License version 3.0 requirements will be
** met: http://www.gnu.org/copyleft/gpl.html.
**
**
** $QT_END_LICENSE$
**
****************************************************************************/
#include "modeltest.h"

#include <QtTest>

#undef Q_ASSERT
#define Q_ASSERT QVERIFY

Q_DECLARE_METATYPE(QModelIndex)

/*!
    Connect to all of the models signals.  Whenever anything happens recheck everything.
*/
ModelTest::ModelTest(QAbstractItemModel *model, QObject *iParent)
    : QObject(iParent)
    , model(model)
    , fetchingMore(false)
{
    Q_ASSERT(model);

    connect(model, &QAbstractItemModel::columnsAboutToBeInserted, this, &ModelTest::runAllTests);
    connect(model, &QAbstractItemModel::columnsAboutToBeRemoved, this, &ModelTest::runAllTests);
    connect(model, &QAbstractItemModel::columnsInserted, this, &ModelTest::runAllTests);
    connect(model, &QAbstractItemModel::columnsRemoved, this, &ModelTest::runAllTests);
    connect(model, &QAbstractItemModel::dataChanged, this, &ModelTest::runAllTests);
    connect(model, &QAbstractItemModel::headerDataChanged, this, &ModelTest::runAllTests);
    connect(model, &QAbstractItemModel::layoutAboutToBeChanged, this, &ModelTest::runAllTests);
    connect(model, &QAbstractItemModel::layoutChanged, this, &ModelTest::runAllTests);
    connect(model, &QAbstractItemModel::modelReset, this, &ModelTest::runAllTests);
    connect(model, &QAbstractItemModel::rowsAboutToBeInserted, this, &ModelTest::runAllTests);
    connect(model, &QAbstractItemModel::rowsAboutToBeRemoved, this, &ModelTest::runAllTests);
    connect(model, &QAbstractItemModel::rowsInserted, this, &ModelTest::runAllTests);
    connect(model, &QAbstractItemModel::rowsRemoved, this, &ModelTest::runAllTests);

    // Special checks for inserting/removing
    connect(model, &QAbstractItemModel::layoutAboutToBeChanged, this, &ModelTest::layoutAboutToBeChanged);
    connect(model, &QAbstractItemModel::layoutChanged, this, &ModelTest::layoutChanged);

    connect(model, &QAbstractItemModel::rowsAboutToBeInserted, this, &ModelTest::rowsAboutToBeInserted);
    connect(model, &QAbstractItemModel::rowsAboutToBeRemoved, this, &ModelTest::rowsAboutToBeRemoved);
    connect(model, &QAbstractItemModel::rowsInserted, this, &ModelTest::rowsInserted);
    connect(model, &QAbstractItemModel::rowsRemoved, this, &ModelTest::rowsRemoved);

    runAllTests();
}

void ModelTest::runAllTests()
{
    if (fetchingMore) {
        return;
    }
    nonDestructiveBasicTest();
    rowCount();
    columnCount();
    hasIndex();
    index();
    parent();
    data();
}

/*!
    nonDestructiveBasicTest tries to call a number of the basic functions (not all)
    to make sure the model doesn't outright segfault, testing the functions that makes sense.
*/
void ModelTest::nonDestructiveBasicTest()
{
    Q_ASSERT(model->buddy(QModelIndex()) == QModelIndex());
    model->canFetchMore(QModelIndex());
    Q_ASSERT(model->columnCount(QModelIndex()) >= 0);
    Q_ASSERT(model->data(QModelIndex()) == QVariant());
    fetchingMore = true;
    model->fetchMore(QModelIndex());
    fetchingMore = false;
    Qt::ItemFlags flags = model->flags(QModelIndex());
    Q_ASSERT(flags == Qt::ItemIsDropEnabled || flags == 0);
    model->hasChildren(QModelIndex());
    model->hasIndex(0, 0);
    model->headerData(0, Qt::Horizontal);
    model->index(0, 0);
    model->itemData(QModelIndex());
    QVariant cache;
    model->match(QModelIndex(), -1, cache);
    model->mimeTypes();
    Q_ASSERT(model->parent(QModelIndex()) == QModelIndex());
    Q_ASSERT(model->rowCount() >= 0);
    QVariant variant;
    model->setData(QModelIndex(), variant, -1);
    model->setHeaderData(-1, Qt::Horizontal, QVariant());
    model->setHeaderData(999999, Qt::Horizontal, QVariant());
    model->sibling(0, 0, QModelIndex());
    model->span(QModelIndex());
    model->supportedDropActions();
}

/*!
    Tests model's implementation of QAbstractItemModel::rowCount() and hasChildren()

    Models that are dynamically populated are not as fully tested here.
 */
void ModelTest::rowCount()
{
    //     qDebug() << "rc";
    // check top row
    QModelIndex topIndex = model->index(0, 0, QModelIndex());
    int rows = model->rowCount(topIndex);
    Q_ASSERT(rows >= 0);
    if (rows > 0) {
        Q_ASSERT(model->hasChildren(topIndex) == true);
    }

    QModelIndex secondLevelIndex = model->index(0, 0, topIndex);
    if (secondLevelIndex.isValid()) { // not the top level
        // check a row count where parent is valid
        rows = model->rowCount(secondLevelIndex);
        Q_ASSERT(rows >= 0);
        if (rows > 0) {
            Q_ASSERT(model->hasChildren(secondLevelIndex) == true);
        }
    }

    // The models rowCount() is tested more extensively in checkChildren(),
    // but this catches the big mistakes
}

/*!
    Tests model's implementation of QAbstractItemModel::columnCount() and hasChildren()
 */
void ModelTest::columnCount()
{
    // check top row
    QModelIndex topIndex = model->index(0, 0, QModelIndex());
    Q_ASSERT(model->columnCount(topIndex) >= 0);

    // check a column count where parent is valid
    QModelIndex childIndex = model->index(0, 0, topIndex);
    if (childIndex.isValid()) {
        Q_ASSERT(model->columnCount(childIndex) >= 0);
    }

    // columnCount() is tested more extensively in checkChildren(),
    // but this catches the big mistakes
}

/*!
    Tests model's implementation of QAbstractItemModel::hasIndex()
 */
void ModelTest::hasIndex()
{
    //     qDebug() << "hi";
    // Make sure that invalid values returns an invalid index
    Q_ASSERT(model->hasIndex(-2, -2) == false);
    Q_ASSERT(model->hasIndex(-2, 0) == false);
    Q_ASSERT(model->hasIndex(0, -2) == false);

    int rows = model->rowCount();
    int columns = model->columnCount();

    // check out of bounds
    Q_ASSERT(model->hasIndex(rows, columns) == false);
    Q_ASSERT(model->hasIndex(rows + 1, columns + 1) == false);

    if (rows > 0) {
        Q_ASSERT(model->hasIndex(0, 0) == true);
    }

    // hasIndex() is tested more extensively in checkChildren(),
    // but this catches the big mistakes
}

/*!
    Tests model's implementation of QAbstractItemModel::index()
 */
void ModelTest::index()
{
    //     qDebug() << "i";
    // Make sure that invalid values returns an invalid index
    Q_ASSERT(model->index(-2, -2) == QModelIndex());
    Q_ASSERT(model->index(-2, 0) == QModelIndex());
    Q_ASSERT(model->index(0, -2) == QModelIndex());

    int rows = model->rowCount();
    int columns = model->columnCount();

    if (rows == 0) {
        return;
    }

    // Catch off by one errors
    Q_ASSERT(model->index(rows, columns) == QModelIndex());
    Q_ASSERT(model->index(0, 0).isValid() == true);

    // Make sure that the same index is *always* returned
    QModelIndex a = model->index(0, 0);
    QModelIndex b = model->index(0, 0);
    Q_ASSERT(a == b);

    // index() is tested more extensively in checkChildren(),
    // but this catches the big mistakes
}

/*!
    Tests model's implementation of QAbstractItemModel::parent()
 */
void ModelTest::parent()
{
    //     qDebug() << "p";
    // Make sure the model wont crash and will return an invalid QModelIndex
    // when asked for the parent of an invalid index.
    Q_ASSERT(model->parent(QModelIndex()) == QModelIndex());

    if (model->rowCount() == 0) {
        return;
    }

    // Column 0                | Column 1    |
    // QModelIndex()           |             |
    //    \- topIndex          | topIndex1   |
    //         \- childIndex   | childIndex1 |

    // Common error test #1, make sure that a top level index has a parent
    // that is a invalid QModelIndex.
    QModelIndex topIndex = model->index(0, 0, QModelIndex());
    Q_ASSERT(model->parent(topIndex) == QModelIndex());

    // Common error test #2, make sure that a second level index has a parent
    // that is the first level index.
    if (model->rowCount(topIndex) > 0) {
        QModelIndex childIndex = model->index(0, 0, topIndex);
        Q_ASSERT(model->parent(childIndex) == topIndex);
    }

    // Common error test #3, the second column should NOT have the same children
    // as the first column in a row.
    // Usually the second column shouldn't have children.
    QModelIndex topIndex1 = model->index(0, 1, QModelIndex());
    if (model->rowCount(topIndex1) > 0) {
        QModelIndex childIndex = model->index(0, 0, topIndex);
        QModelIndex childIndex1 = model->index(0, 0, topIndex1);
        Q_ASSERT(childIndex != childIndex1);
    }

    // Full test, walk n levels deep through the model making sure that all
    // parent's children correctly specify their parent.
    checkChildren(QModelIndex());
}

/*!
    Called from the parent() test.

    A model that returns an index of parent X should also return X when asking
    for the parent of the index.

    This recursive function does pretty extensive testing on the whole model in an
    effort to catch edge cases.

    This function assumes that rowCount(), columnCount() and index() already work.
    If they have a bug it will point it out, but the above tests should have already
    found the basic bugs because it is easier to figure out the problem in
    those tests then this one.
 */
void ModelTest::checkChildren(const QModelIndex &iParent, int currentDepth)
{
    // First just try walking back up the tree.
    QModelIndex p = iParent;
    while (p.isValid()) {
        p = p.parent();
    }

    // For models that are dynamically populated
    if (model->canFetchMore(iParent)) {
        fetchingMore = true;
        model->fetchMore(iParent);
        fetchingMore = false;
    }

    int rows = model->rowCount(iParent);
    int columns = model->columnCount(iParent);

    if (rows > 0) {
        Q_ASSERT(model->hasChildren(iParent));
    }

    // Some further testing against rows(), columns(), and hasChildren()
    Q_ASSERT(rows >= 0);
    Q_ASSERT(columns >= 0);
    if (rows > 0) {
        Q_ASSERT(model->hasChildren(iParent) == true);
    }

    // qDebug() << "iParent:" << model->data(iParent).toString() << "rows:" << rows
    //         << "columns:" << columns << "iParent column:" << iParent.column();

    Q_ASSERT(model->hasIndex(rows + 1, 0, iParent) == false);
    for (int r = 0; r < rows; ++r) {
        if (model->canFetchMore(iParent)) {
            fetchingMore = true;
            model->fetchMore(iParent);
            fetchingMore = false;
        }
        Q_ASSERT(model->hasIndex(r, columns + 1, iParent) == false);
        for (int c = 0; c < columns; ++c) {
            Q_ASSERT(model->hasIndex(r, c, iParent) == true);
            QModelIndex idx = model->index(r, c, iParent);
            // rowCount() and columnCount() said that it existed...
            Q_ASSERT(idx.isValid() == true);

            // index() should always return the same index when called twice in a row
            QModelIndex modifiedIndex = model->index(r, c, iParent);
            Q_ASSERT(idx == modifiedIndex);

            // Make sure we get the same index if we request it twice in a row
            QModelIndex a = model->index(r, c, iParent);
            QModelIndex b = model->index(r, c, iParent);
            Q_ASSERT(a == b);

            // Some basic checking on the index that is returned
            Q_ASSERT(idx.model() == model);
            Q_ASSERT(idx.row() == r);
            Q_ASSERT(idx.column() == c);
            // While you can technically return a QVariant usually this is a sign
            // of an bug in data()  Disable if this really is ok in your model.
            Q_ASSERT(model->data(idx, Qt::DisplayRole).isValid() == true);

            // If the next test fails here is some somewhat useful debug you play with.

            if (model->parent(idx) != iParent) {
                qDebug() << r << c << currentDepth << model->data(idx).toString() << model->data(iParent).toString();
                qDebug() << idx << iParent << model->parent(idx);
                //                 And a view that you can even use to show the model.
                //                 QTreeView view;
                //                 view.setModel(model);
                //                 view.show();
            }

            // Check that we can get back our real parent.
            //             qDebug() << model->parent ( index ) << parent;
            Q_ASSERT(model->parent(idx) == iParent);

            // recursively go down the children
            if (model->hasChildren(idx) && currentDepth < 10) {
                // qDebug() << r << c << "has children" << model->rowCount(index);
                checkChildren(idx, ++currentDepth);
            } /* else { if (currentDepth >= 10) qDebug() << "checked 10 deep"; };*/

            // make sure that after testing the children that the index doesn't change.
            QModelIndex newerIndex = model->index(r, c, iParent);
            Q_ASSERT(idx == newerIndex);
        }
    }
}

/*!
    Tests model's implementation of QAbstractItemModel::data()
 */
void ModelTest::data()
{
    // Invalid index should return an invalid qvariant
    Q_ASSERT(!model->data(QModelIndex()).isValid());

    int nbRows = model->rowCount();
    int nbColumns = model->columnCount();
    if (nbRows == 0 || nbColumns == 0) {
        return;
    }

    for (int r = 0; r < nbRows; ++r) {
        for (int c = 0; c < nbColumns; ++c) {
            // A valid index should have a valid QVariant data
            Q_ASSERT(model->index(r, c).isValid());

            // shouldn't be able to set data on an invalid index
            Q_ASSERT(model->setData(QModelIndex(), QStringLiteral("foo"), Qt::DisplayRole) == false);

            // General Purpose roles that should return a QString
            QVariant variant = model->data(model->index(r, c), Qt::ToolTipRole);
            if (variant.isValid()) {
                Q_ASSERT(variant.canConvert<QString>());
            }
            variant = model->data(model->index(r, c), Qt::StatusTipRole);
            if (variant.isValid()) {
                Q_ASSERT(variant.canConvert<QString>());
            }
            variant = model->data(model->index(r, c), Qt::WhatsThisRole);
            if (variant.isValid()) {
                Q_ASSERT(variant.canConvert<QString>());
            }

            // General Purpose roles that should return a QSize
            variant = model->data(model->index(r, c), Qt::SizeHintRole);
            if (variant.isValid()) {
                Q_ASSERT(variant.canConvert<QSize>());
            }

            // MANKOWSKI: UserRole
            variant = model->data(model->index(r, c), Qt::UserRole);
            if (variant.isValid()) {
                Q_ASSERT(variant.canConvert<QString>());
            }

            // General Purpose roles that should return a QFont
            QVariant fontVariant = model->data(model->index(r, c), Qt::FontRole);
            if (fontVariant.isValid()) {
                Q_ASSERT(fontVariant.canConvert<QFont>());
            }

            // Check that the alignment is one we know about
            QVariant textAlignmentVariant = model->data(model->index(r, c), Qt::TextAlignmentRole);
            if (textAlignmentVariant.isValid()) {
                int alignment = textAlignmentVariant.toInt();
                Q_ASSERT(static_cast<unsigned int>(alignment) == static_cast<unsigned int>(alignment & (Qt::AlignHorizontal_Mask | Qt::AlignVertical_Mask)));
            }

            // General Purpose roles that should return a QColor
            QVariant colorVariant = model->data(model->index(r, c), Qt::BackgroundRole);
            if (colorVariant.isValid()) {
                Q_ASSERT(colorVariant.canConvert<QColor>());
            }

            colorVariant = model->data(model->index(r, c), Qt::ForegroundRole);
            if (colorVariant.isValid()) {
                Q_ASSERT(colorVariant.canConvert<QColor>());
            }

            // Check that the "check state" is one we know about.
            QVariant checkStateVariant = model->data(model->index(r, c), Qt::CheckStateRole);
            if (checkStateVariant.isValid()) {
                int state = checkStateVariant.toInt();
                Q_ASSERT(state == Qt::Unchecked || state == Qt::PartiallyChecked || state == Qt::Checked);
            }
        }
    }
}

/*!
    Store what is about to be inserted to make sure it actually happens

    \sa rowsInserted()
 */
void ModelTest::rowsAboutToBeInserted(const QModelIndex &iParent, int start, int end)
{
    Q_UNUSED(end)
    //    qDebug() << "rowsAboutToBeInserted" << "start=" << start << "end=" << end << "parent=" << model->data ( parent ).toString()
    //    << "current count of parent=" << model->rowCount ( parent );  // << "display of last=" << model->data( model->index(start-1, 0, parent) );
    //     qDebug() << model->index(start-1, 0, parent) << model->data( model->index(start-1, 0, parent) );
    Changing c;
    c.parent = iParent;
    c.oldSize = model->rowCount(iParent);
    c.last = model->data(model->index(start - 1, 0, iParent));
    c.next = model->data(model->index(start, 0, iParent));
    insert.push(c);
}

/*!
    Confirm that what was said was going to happen actually did

    \sa rowsAboutToBeInserted()
 */
void ModelTest::rowsInserted(const QModelIndex &iParent, int start, int end)
{
    Changing c = insert.pop();
    Q_ASSERT(c.parent == iParent);
    //    qDebug() << "rowsInserted"  << "start=" << start << "end=" << end << "oldsize=" << c.oldSize
    //    << "parent=" << model->data ( parent ).toString() << "current rowcount of parent=" << model->rowCount ( parent );

    //    for (int ii=start; ii <= end; ii++)
    //    {
    //      qDebug() << "itemWasInserted:" << ii << model->data ( model->index ( ii, 0, parent ));
    //    }
    //    qDebug();

    Q_ASSERT(c.oldSize + (end - start + 1) == model->rowCount(iParent));
    Q_ASSERT(c.last == model->data(model->index(start - 1, 0, c.parent)));

    if (c.next != model->data(model->index(end + 1, 0, c.parent))) {
        qDebug() << start << end;
        for (int i = 0; i < model->rowCount(); ++i) {
            qDebug() << model->index(i, 0).data().toString();
        }
        qDebug() << c.next << model->data(model->index(end + 1, 0, c.parent));
    }

    Q_ASSERT(c.next == model->data(model->index(end + 1, 0, c.parent)));
}

void ModelTest::layoutAboutToBeChanged()
{
    for (int i = 0; i < qBound(0, model->rowCount(), 100); ++i) {
        changing.append(QPersistentModelIndex(model->index(i, 0)));
    }
}

void ModelTest::layoutChanged()
{
    for (int i = 0; i < changing.count(); ++i) {
        QPersistentModelIndex p = changing.at(i);
        Q_ASSERT(p == model->index(p.row(), p.column(), p.parent()));
    }
    changing.clear();
}

/*!
    Store what is about to be inserted to make sure it actually happens

    \sa rowsRemoved()
 */
void ModelTest::rowsAboutToBeRemoved(const QModelIndex &iParent, int start, int end)
{
    qDebug() << "ratbr" << iParent << start << end;
    Changing c;
    c.parent = iParent;
    c.oldSize = model->rowCount(iParent);
    c.last = model->data(model->index(start - 1, 0, iParent));
    c.next = model->data(model->index(end + 1, 0, iParent));
    remove.push(c);
}

/*!
    Confirm that what was said was going to happen actually did

    \sa rowsAboutToBeRemoved()
 */
void ModelTest::rowsRemoved(const QModelIndex &iParent, int start, int end)
{
    qDebug() << "rr" << iParent << start << end;
    Changing c = remove.pop();
    Q_ASSERT(c.parent == iParent);
    Q_ASSERT(c.oldSize - (end - start + 1) == model->rowCount(iParent));
    Q_ASSERT(c.last == model->data(model->index(start - 1, 0, c.parent)));
    Q_ASSERT(c.next == model->data(model->index(start, 0, c.parent)));
}
